> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://typeform.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://typeform.ferndocs.com/_mcp/server.

# Retrieve custom form messages

GET https://api.typeform.com/forms/{form_id}/messages

Retrieves the customizable messages for a form (specified by `form_id`) using the form's  specified language.

You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.

Reference: https://typeform.ferndocs.com/documentation/create-api/api-reference/forms/messages

## Authentication

- `Authorization` header (bearer token, required) — Bearer token authentication. Tokens can be generated from the user account. Privileges needed may vary.
- `Authorization` header (required) — A string representation of JWT containing at least two parameters: `ctx.user_id` — user's id `ctx.account_id` — user's default account id `ctx.account_uid` — user's default account uid The usage of account_(u)id from JWT is discouraged, user can have access to multiple accounts, every endpoint has to be account aware if it's needed. This JWT must be signed by the appropriate authority.

## Request

### Path parameters

- `form_id` (any, required) — Unique ID for the form. Find in your form URL. For example, in the URL "https://mysite.typeform.com/to/u6nXL7" the form_id is `u6nXL7`.

## Response

### 200

OK

- `label.buttonHint.default` (string, optional) — Default tooltip button message. Maximum 28 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.buttonHint.longtext` (string, optional) — Tooltip button message for long text blocks. Maximum 28 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.warning.connection` (string, optional) — Server connection error message. Maximum 128 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.buttonNoAnswer.default` (string, optional) — Default continue button message. Maximum 100 characters.
- `label.warning.correction` (string, optional) — List of errors message. Maximum 128 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `block.payment.cardNameTitle` (string, optional) — Credit card name message. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `block.payment.cardNumberTitle` (string, optional) — Credit card number message. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `block.payment.cvcDescription` (string, optional) — Credit card security number message
- `block.payment.cvcNumberTitle` (string, optional) — Credit card CVC number message. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `block.shortText.placeholder` (string, optional) — Text input placeholder. Maximum 100 characters.
- `label.error.emailAddress` (string, optional) — Invalid email error message. Maximum 64 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.error.expiryMonthTitle` (string, optional) — Credit card expiry month message. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.error.expiryYearTitle` (string, optional) — Credit card expiry year message. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.warning.fallbackAlert` (string, optional) — Fallback alert message. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `block.fileUpload.choose` (string, optional) — File upload button message. Maximum 34 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `block.fileUpload.drag` (string, optional) — File upload dragging action message. Maximum 35 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `block.fileUpload.uploadingProgress` (string, optional) — Still processing file upload message. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.error.sizeLimit` (string, optional) — File too big error message. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.warning.formUnavailable` (string, optional) — Private form error message. Accepts variable `form:name`. Maximum 128 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.error.incompleteForm` (string, optional) — Incomplete fields error message. Maximum 42 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.hint.key` (string, optional) — Key letter hint message. Maximum 100 characters.
- `block.legal.reject` (string, optional) — Legal field deny message. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `block.legal.accept` (string, optional) — Legal field accept message. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.error.maxValue` (string, optional) — Number maximum value tooltip message. Accepts variable `field:max`. Maximum 64 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.error.maxLength` (string, optional) — Text fields maximum length tooltip message. Accepts variable `field:max_length`. Maximum 64 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.error.minValue` (string, optional) — Number minimum value tooltip message. Accepts variable `field:min`. Maximum 64 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.error.range` (string, optional) — Number minimum and maximum range value tooltip message. Accepts variables `field:min` and `field:max`. Maximum 64 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `block.multipleChoice.hint` (string, optional) — Choose as many as you like message for multiple choice fields. Maximum 45 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.error.mustEnter` (string, optional) — Required value error message. Maximum 64 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.error.mustSelect` (string, optional) — Required selection error message. Maximum 64 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.no.shortcut` (string, optional) — Keyboard shortcut for the "No" option. Maximum 1 character.
- `label.no.default` (string, optional) — Representation for the word "No." You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `block.dropdown.hint` (string, optional) — Not suggestions found for dropdown fields error message. Maximum 64 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `block.multipleChoice.other` (string, optional) — Other answer message. Maximum 100 characters.
- `label.progress.percent` (string, optional) — Completion percentage message. Accepts variable `progress:percent`. Maximum 100 characters.
- `label.progress.proportion` (string, optional) — Completion proportion message. Accepts variables `progress:step` and `progress:total`. Maximum 100 characters.
- `label.error.required` (string, optional) — Required field error message. Maximum 64 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.preview` (string, optional) — Review fields error message. Accepts variable `form:unanswered_fields`. Maximum 64 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.button.review` (string, optional) — Review button message. Maximum 100 characters.
- `label.error.server` (string, optional) — Server error message. Maximum 128 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.action.share` (string, optional) — Share text message. Maximum 100 characters.
- `label.button.submit` (string, optional) — Submit button message. Maximum 100 characters.
- `label.warning.success` (string, optional) — Successful submit message. Maximum 128 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.button.ok` (string, optional) — Answer confirm. Maximum 100 characters.
- `label.error.mustAccept` (string, optional) — Legal field terms and conditions message. Maximum 64 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `block.longtext.hint` (string, optional) — Long text field tooltip message. Maximum 128 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `block.dropdown.placeholder` (string, optional) — Placeholder message with instructions for dropdown fields. Maximum 100 characters.
- `block.dropdown.placeholderTouch` (string, optional) — Placeholder message with instructions for dropdown fields on touch devices. Maximum 100 characters.
- `label.error.url` (string, optional) — Invalid URL error message. Maximum 64 characters. You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.
- `label.yes.shortcut` (string, optional) — Keyboard shortcut for the "Yes" option. Maximum 1 character.
- `label.yes.default` (string, optional) — Representation for the word "Yes". You can format messages with bold (`*bold*`) and italic (`_italic_`) text. HTML tags are forbidden.

## Examples

**Response**

```json
{
  "label.buttonHint.default": "string",
  "label.buttonHint.longtext": "string",
  "label.warning.connection": "string",
  "label.buttonNoAnswer.default": "string",
  "label.warning.correction": "string",
  "block.payment.cardNameTitle": "string",
  "block.payment.cardNumberTitle": "string",
  "block.payment.cvcDescription": "string",
  "block.payment.cvcNumberTitle": "string",
  "block.shortText.placeholder": "string",
  "label.error.emailAddress": "string",
  "label.error.expiryMonthTitle": "string",
  "label.error.expiryYearTitle": "string",
  "label.warning.fallbackAlert": "string",
  "block.fileUpload.choose": "string",
  "block.fileUpload.drag": "string",
  "block.fileUpload.uploadingProgress": "string",
  "label.error.sizeLimit": "string",
  "label.warning.formUnavailable": "string",
  "label.error.incompleteForm": "string",
  "label.hint.key": "string",
  "block.legal.reject": "string",
  "block.legal.accept": "string",
  "label.error.maxValue": "string",
  "label.error.maxLength": "string",
  "label.error.minValue": "string",
  "label.error.range": "string",
  "block.multipleChoice.hint": "string",
  "label.error.mustEnter": "string",
  "label.error.mustSelect": "string",
  "label.no.shortcut": "string",
  "label.no.default": "string",
  "block.dropdown.hint": "string",
  "block.multipleChoice.other": "string",
  "label.progress.percent": "string",
  "label.progress.proportion": "string",
  "label.error.required": "string",
  "label.preview": "string",
  "label.button.review": "string",
  "label.error.server": "string",
  "label.action.share": "string",
  "label.button.submit": "string",
  "label.warning.success": "string",
  "label.button.ok": "string",
  "label.error.mustAccept": "string",
  "block.longtext.hint": "string",
  "block.dropdown.placeholder": "string",
  "block.dropdown.placeholderTouch": "string",
  "label.error.url": "string",
  "label.yes.shortcut": "string",
  "label.yes.default": "string"
}
```

**SDK Code**

```python
import requests

url = "https://api.typeform.com/forms/:form_id/messages"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.typeform.com/forms/:form_id/messages';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.typeform.com/forms/:form_id/messages"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.typeform.com/forms/:form_id/messages")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.typeform.com/forms/:form_id/messages")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.typeform.com/forms/:form_id/messages', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.typeform.com/forms/:form_id/messages");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.typeform.com/forms/:form_id/messages")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```